;**
;* Coded by Remi Meier  2006 _
;* hope it works as expected ;) _

;* <p>
;* <b>ATTENTION</b>
;* Read the <b>ReadMe.html :D</b>_
;* </p>

;* <b>ToDo:</b> _
;* A bit of syntax-coloring _

;** /notstart _



;{- Test


DisableExplicit
XIncludeFile "lexer.pbi"

Global aaa_Ddd.iPBSC

;** d
;* aha? 
;* doch!
ProcedureDLL d()
EndProcedure
ProcedureCDLL k()
EndProcedure

#ConstTest = 5  ;* a Test for a constant
Enumeration
  #c1 ;* unimportant const
  #c2
  #c3
  #c4
EndEnumeration
;** #c2
;* important const
;** c #c3
;* very important one!! :D

;** s test
;* Just a structure for testing
CompilerIf Defined(POINT, #PB_Structure)
Structure test Extends POINT
  elem1.s ;* you can also put a description here!
  elem2.l ;* or here ;), you can just document an element ONCE! (else overwritten)
  elem3.l : elem4.l
EndStructure
CompilerEndIf
;** s .elem3
;* the third element can be addressed like this
;* when you before adressed the structure/interface explicitly.
;* you can even leave the "s "
;** s tesT.elem4
;* normal


;** i itest.elem4
;* "i" for showing: it's an interface. "s " would work here, too!
;** i itest
;* An interface description
Interface itest
  elem1.s(a.l, b.c) ;* the first element
  elem2.l(d.s) ;* the second element
  elem3.l(f.d)
  elem4.l()
EndInterface


;** testmacro
;* a testmacro simple mode
Macro testmacro
  a.l
EndMacro

;** othermacro
;* a testmacro complex mode
;** .a
;* first parameter
;** .b
;* second parameter
Macro othermacro(a, b=4)
  a = b
EndMacro

;}- EndTest




EnableExplicit
#DQUOTE$ = Chr('"')



XIncludeFile "lexer.pbi"

;#MAX_FILES = 10
#MAX_PARAMETERS = 30
#MAX_ELEMENTS = 50
;;** #MAX_FILES
;;* The maximum of files that can be processed at once
;** #MAX_PARAMETERS
;* The maximum of parameters a procedure can have
;** #MAX_ELEMENTS
;* The maximum of elements a structure/interface can have
#StringNotStart  = 1
#StringOnlyStart = 2

;** s globals: a structure with global variables in it
Structure GLOBALS
  FilterStartWith.s[16]
  FilterNotStartWith.s[16]
  FilterOnlyDLLs.l
  FilterNoDLLTable.l
  FilterNoFunctions.l
  FilterNoGlobals.l
  FilterNoStructs.l
  FilterNoConstants.l
  FilterNoSortParam.l
  FilterNoSortField.l
  FilterNoSortPaFl.l
  FilterNoSort.l
  StyleSheet.s
  CurrentFileName.s
EndStructure

;{

;** s token: A token of the parsed source file
Structure TOKEN
  LineNb.l
  s.s
  Type.l
EndStructure

;** s param: a parameter of a procedure
Structure PARAM
  Name.s
  lcName.s
  Desc.s
EndStructure

;** s function: a structure for the functions
Structure FUNCTION
  FileName.s
  Name.s
  lcName.s
  Line.s ;* func.d(a.l, b.d)
  ShortDesc.s
  Params.PARAM[#MAX_PARAMETERS]
  Export.l ;* DLL or not
EndStructure

;** s include: a structure for the includes
Structure INCLUDE
  FileName.s
  Name.s
  Path.s
  lcPath.s
EndStructure

;** s globalvars: a structure for all global variables
Structure GLOBALVARS
  FileName.s
  Name.s
  lcName.s
  Line.s ; name + type
  ShortDesc.s
EndStructure

;** s elems: a structure for the elements of a structure
Structure ELEMS
  Name.s
  lcName.s
  Line.s
  Desc.s
EndStructure

;** s Struct_interf: a structure holding the information about structures and interfaces
Structure STRUCT_INTERF
  FileName.s
  lcName.s
  Name.s
  Parent.s
  Elems.ELEMS[#MAX_ELEMENTS]
  ShortDesc.s
EndStructure

;** s Constant: a structure for the constants
Structure CONSTANT
  FileName.s
  Name.s
  lcName.s
  Desc.s
EndStructure

Structure FILEDESC
  FileName.s
  FileDesc.s
EndStructure

Structure REPLACECHARS
  chars.c[50]
  strings.s[50]
EndStructure
;}

Global NewList token.TOKEN()
Global NewList function.FUNCTION()
Global NewList include.INCLUDE()
Global NewList globalvar.GLOBALVARS()
Global NewList strucinterf.STRUCT_INTERF()
Global NewList constant.CONSTANT()
Global NewList filestoparse.String()
Global NewList filedesc.FILEDESC()
Global glob.GLOBALS
;** g glob: glob is a global variable...
;** g token: global list with the scanned pb-file
;** g function: the list of functions
;** g include: the list of includes used in this file
;** g globalvar: all global variables 
;** g strucinterf: list for all structures and interfaces


;** processprogramparameter
;* checks, if s.s is a parameter and then fills the global structure
;* if possible. _
;* It returns param.s if it wasn't used. _
;* inFile needs to be specified for parameter-comment-processing
Procedure.s ProcessProgramParameter(s.s, param.s, inFile = #False)
  Protected Result.s = param
  Protected i
  
  s = LCase(s)
  Select s
    Case "/stylesheet"
      glob\StyleSheet = param
      Result = ""
      
    Case "/notstart"
      For i=0 To CountString(param,";")
        glob\FilterNotStartWith[i] = Trim(LCase(StringField(param,i+1,";")))
      Next
      Result = ""
    
    Case "/onlystart"
      For i=0 To CountString(param,";")
        glob\FilterStartWith[i] = Trim(LCase(StringField(param,i+1,";")))
      Next
      Result = ""
    
    Case "/onlydll"
      glob\FilterOnlyDLLs = #True
      
    Case "/nodlltable"
      glob\FilterNoDLLTable = #True
      
    Case "/nofunctions"
      glob\FilterNoFunctions = #True
      
    Case "/noglobals"
      glob\FilterNoGlobals = #True
      
    Case "/nostructs"
      glob\FilterNoStructs = #True
      
    Case "/noconstants"
      glob\FilterNoConstants = #True
      
    Case "/nosortparam"
      glob\FilterNoSortParam = #True
      
    Case "/nosortfield"
      glob\FilterNoSortField = #True
      
    Case "/nosortpafl"
      glob\FilterNoSortPaFl = #True
      
    Case "/nosort"
      glob\FilterNoSort = #True
      
    Default
      If Not inFile
        AddElement(filestoparse())
        filestoparse()\s = s
      
      Else
        ; return something to indicate failure
        Result = s
      EndIf
  EndSelect
  
  ProcedureReturn Result
EndProcedure

;** getfilenamefromparameter
;* examines the file names and filters through the program parameters.
Procedure GetFileNameFromParameter()
  Protected s.s, z.l
  
  s = ProgramParameter()
  While s
    s = ProcessProgramParameter(s, ProgramParameter())
    
    If s = ""
      ; if either second argument of ProcessProgramParameter() was used 
      ; or no more parameters available
      
      s = ProgramParameter()  ; ensure that it was the last parameter
                              ; or just get the next one
    EndIf
  Wend
EndProcedure

;** loadfile: loads the file and tokenizes it
;** .FileName: path of file to load
Procedure.l LoadFile(FileName.s)
  Protected inFile.iPBSC
  
  inFile = New_PBSC()
  If Not inFile : ProcedureReturn #False : EndIf
  
  ClearList(token())
  If inFile\SetFile(FileName) 
    While inFile\IsNextToken() 
      AddElement(token())
      token()\s      = inFile\GetNextToken()
      token()\LineNb = inFile\GetCurrentLineNb()
      token()\Type   = inFile\GetCurrentType()
    Wend
    
    Delete_PBSC(inFile)
    ProcedureReturn #True
  EndIf
  
  Delete_PBSC(inFile)
  ProcedureReturn #False
EndProcedure

;** validelement: checks if the name is ok with the filters
Procedure.l ValidElement(Name.s)
  Protected Add.l = #True
  Protected i.l
  
  Name = LCase(Name)
  For i=0 To 15
    If glob\FilterNotStartWith[i]
      If Left(Name, Len(glob\FilterNotStartWith[i])) = glob\FilterNotStartWith[i]
        Add = #False :: Break
      Else
        Add = #True
      EndIf
    ElseIf glob\FilterStartWith[i]
      If Left(Name, Len(glob\FilterStartWith[i])) = glob\FilterStartWith[i]
        Add = #True
      Else
        Add = #False :: Break
      EndIf
    EndIf
  Next
  
  ProcedureReturn Add
EndProcedure

;** replacemultiplechars
;* Replaces multiple chars with strings
;** .String: String where chars shall be replaced
;** .*characters: A structure with chars and strings which 
;* shall be replaced by what
Procedure.s ReplaceMultipleChars(String.s, *Characters.REPLACECHARS)
  Protected *Char.CHARACTER, result.s, z.l, Add.s, found.l
  
  If (Not Bool(String)) Or (Not *characters)
    ProcedureReturn String
  EndIf
  
  *Char = @String
  While *Char\c <> 0
    Add = ""
    found = #False
    
    For z = 0 To 49
      If *Char\c = *Characters\chars[z]
        Add = *Characters\strings[z]
        found = #True
        Break
      ElseIf *Characters\chars[z] = 0
        Break
      EndIf
    Next
    
    If Not found
      Add = Chr(*Char\c)
    EndIf
    
    result + Add
    *Char + SizeOf(CHARACTER)
  Wend
  
  ProcedureReturn result
EndProcedure

;** preprocesshtmlline
;* Changes a '_' at the end of the line to a line break _
;* some others...
Procedure.s PreProcessHTMLLine(Line.s)
  Protected chars.REPLACECHARS
  ; Change special chars
  Line = Trim(Line)
  chars\chars[0] = '&'
  chars\strings[0] = "&amp;"
  chars\chars[1] = '"'
  chars\strings[1] = "&quot;"
  chars\chars[2] = ''
  chars\strings[2] = "&auml;"
  chars\chars[3] = ''
  chars\strings[3] = "&Auml;"
  chars\chars[4] = ''
  chars\strings[4] = "&uuml;"
  chars\chars[5] = ''
  chars\strings[5] = "&Uuml;"
  chars\chars[6] = ''
  chars\strings[6] = "&ouml;"
  chars\chars[7] = ''
  chars\strings[7] = "&Ouml;"
  chars\chars[8] = ''
  chars\strings[8] = "&szlig;"
  chars\chars[9] = ''
  chars\strings[9] = "&copy;"
  chars\chars[10] = ''
  chars\strings[10] = "&reg;"
  chars\chars[11] = ''
  chars\strings[11] = "&laquo;"
  chars\chars[12] = ''
  chars\strings[12] = "&raquo;"
  chars\chars[13] = ''
  chars\strings[13] = "&sect;"
  chars\chars[14] = ''
  chars\strings[14] = "&brvbar;"
  chars\chars[15] = ''
  chars\strings[15] = "&Agrave;"
  chars\chars[16] = ''
  chars\strings[16] = "&Aacute;"
  chars\chars[17] = ''
  chars\strings[17] = "&Acirc;"
  chars\chars[18] = ''
  chars\strings[18] = "&Egrave;"
  chars\chars[19] = ''
  chars\strings[19] = "&Eacute;"
  chars\chars[20] = ''
  chars\strings[20] = "&Ecirc;"
  chars\chars[21] = ''
  chars\strings[21] = "&Igrave;"
  chars\chars[22] = ''
  chars\strings[22] = "&Iacute;"
  chars\chars[23] = ''
  chars\strings[23] = "&Icirc;"
  chars\chars[24] = ''
  chars\strings[24] = "&Ograve;"
  chars\chars[25] = ''
  chars\strings[25] = "&Oacute;"
  chars\chars[26] = ''
  chars\strings[26] = "&Ocirc;"
  chars\chars[27] = ''
  chars\strings[27] = "&Ugrave;"
  chars\chars[28] = ''
  chars\strings[28] = "&Uacute;"
  chars\chars[29] = ''
  chars\strings[29] = "&Ucirc;"
  chars\chars[30] = ''
  chars\strings[30] = "&agrave;"
  chars\chars[31] = ''
  chars\strings[31] = "&aacute;"
  chars\chars[32] = ''
  chars\strings[32] = "&acirc;"
  chars\chars[33] = ''
  chars\strings[33] = "&egrave;"
  chars\chars[34] = ''
  chars\strings[34] = "&eacute;"
  chars\chars[35] = ''
  chars\strings[35] = "&ecirc;"
  chars\chars[36] = ''
  chars\strings[36] = "&igrave;"
  chars\chars[37] = ''
  chars\strings[37] = "&iacute;"
  chars\chars[38] = ''
  chars\strings[38] = "&icirc;"
  chars\chars[39] = ''
  chars\strings[39] = "&ograve;"
  chars\chars[40] = ''
  chars\strings[40] = "&oacute;"
  chars\chars[41] = ''
  chars\strings[41] = "&ocirc;"
  chars\chars[42] = ''
  chars\strings[42] = "&ugrave;"
  chars\chars[43] = ''
  chars\strings[43] = "&uacute;"
  chars\chars[44] = ''
  chars\strings[44] = "&ucirc;"
  Line = ReplaceMultipleChars(Line, @chars)
  
  While Right(Line, 1) = "_"
    Line = Left(Line, Len(Line) - 1) + "<br>"
  Wend
  
  ProcedureReturn Line
EndProcedure

;** RestyleCode
;* Inserts links to structures (extern or intern)
;* Restyles a bit
Procedure.s RestyleCode(Line.s)
  Protected *currentElement, pos.l, lcLine.s, result.s, Temp.s, lcToken.s, found.l
  Protected lex.iPBSC = New_PBSC()
  Protected NewList ltoken.TOKEN()
  lex\SetFileString(Line)
  *currentElement = @strucinterf()
  
  While lex\IsNextToken() 
    AddElement(ltoken())
    ltoken()\s      = lex\GetNextToken()
    ltoken()\LineNb = lex\GetCurrentLineNb()
    ltoken()\Type   = lex\GetCurrentType()
  Wend
  
  result = ""
  ForEach ltoken()
    lcToken = LCase(ltoken()\s)
    
    If ltoken()\s = ","
      Temp = ltoken()\s + " "
      
    ElseIf lcToken = "extends"
      Temp = " "+ltoken()\s + " "
      
    ElseIf lcToken = "="
      Temp = " "+ltoken()\s + " "
      
    ElseIf ltoken()\Type = #PBSC_Identifier And PreviousElement(ltoken())
      If (ltoken()\s = "." Or LCase(ltoken()\s) = "extends")
        NextElement(ltoken())
        ; found a Struc/interf
        
        found = #False
        ForEach strucinterf()
          If strucinterf()\lcName = lcToken
            found = #True
            If strucinterf()\FileName = glob\CurrentFileName
              Temp = "<a href="+#DQUOTE$+"#s_"+lcToken+#DQUOTE$+">"+ltoken()\s+"</a>"
            Else
              Temp = "<a href="+#DQUOTE$+strucinterf()\FileName+".html#s_"+lcToken+#DQUOTE$+">"+ltoken()\s+"</a>"
            EndIf
            
            Break
          EndIf
        Next
        
        If Not found
          Temp = ltoken()\s
        EndIf
      Else
        NextElement(ltoken())
        Temp = ltoken()\s
      EndIf
      
    Else
      Temp = ltoken()\s
    EndIf
    
    result + Temp
  Next
  
  ChangeCurrentElement(strucinterf(), *currentElement)
  Delete_PBSC(lex)
  ProcedureReturn result
EndProcedure

;** resetarray
;* resets all memory to 0
Procedure ResetArray(*mem, Size.l)
  Protected *b.Byte
  
  For *b = *mem To *mem + Size - 1
    *b\b = 0
  Next
EndProcedure

;** fillTargetFunction: adds a description to a function/param
;** .Target: target like "functionname.param"
;** .Desc: the description for the function/param
Procedure FillTargetFunction(Target.s, Desc.s)
  Protected lcFuncName.s, isParameter.l, ParamName.s, found.l, z.l, lcParamName.s
  
  lcFuncName = Trim(LCase(StringField(Target, 1, ".")))
  ParamName = Trim(StringField(Target, 2, "."))
  If ParamName
    isParameter = #True
  EndIf
  
  
  If ValidElement(lcFuncName)
    found = #False
    ForEach function()
      If function()\lcName = lcFuncName And function()\FileName = glob\CurrentFileName
        found = #True
        Break
      EndIf
    Next
    
    If Not found
      AddElement(function())
      function()\lcName = lcFuncName
      function()\FileName = glob\CurrentFileName
    EndIf
    
    If isParameter
      lcParamName = LCase(ParamName)
      For z = 0 To #MAX_PARAMETERS-1
        If function()\Params[z]\lcName = lcParamName
          If function()\Params[z]\Desc And Desc
            PrintN("Warning: You overwrite a documentation of the parameter "+function()\Params[z]\lcName)
            function()\Params[z]\Desc = Desc
          ElseIf Desc
            function()\Params[z]\Desc = Desc
          EndIf
          
          Break
        ElseIf function()\Params[z]\lcName = ""
          function()\Params[z]\lcName = lcParamName
          function()\Params[z]\Desc = Desc
          Break
        EndIf
      Next
    Else
      If function()\ShortDesc And Desc
        PrintN("Warning: You overwrite a documentation of the function "+function()\lcName)
        function()\ShortDesc = Desc
      ElseIf Desc
        function()\ShortDesc = Desc
      EndIf
    EndIf
  EndIf
EndProcedure

;** FillTargetStructure
;* Adds a description to a structure/interface (element)
;** .Target: target like "structurename.elem"
;** .Desc: the description for the structure/interface/element
Procedure FillTargetStructure(Target.s, Desc.s)
  Protected lcStrucName.s, isElem.l, ElemName.s, found.l, z.l, lcElemName.s
  
  Target = Trim(Right(LCase(Target), Len(Target) - 2))
  lcStrucName = Trim(LCase(StringField(Target, 1, ".")))
  ElemName = Trim(StringField(Target, 2, "."))
  
  If ElemName
    isElem = #True
  EndIf
  
  If ValidElement(lcStrucName)
    found = #False
    ForEach strucinterf()
      If strucinterf()\lcName = lcStrucName And strucinterf()\FileName = glob\CurrentFileName
        found = #True
        Break
      EndIf
    Next
    
    If Not found
      AddElement(strucinterf())
      strucinterf()\lcName = lcStrucName
      strucinterf()\FileName = glob\CurrentFileName
    EndIf
    
    If isElem
      lcElemName = LCase(ElemName)
      For z = 0 To #MAX_ELEMENTS-1
        If strucinterf()\Elems[z]\lcName = lcElemName
          If strucinterf()\Elems[z]\Desc And Desc
            PrintN("Warning: You overwrite a documentation of the element "+strucinterf()\Elems[z]\lcName)
            strucinterf()\Elems[z]\Desc = Desc
          ElseIf Desc
            strucinterf()\Elems[z]\Desc = Desc
          EndIf
          Break
        ElseIf strucinterf()\Elems[z]\lcName = ""
          strucinterf()\Elems[z]\lcName = lcElemName
          strucinterf()\Elems[z]\Desc = Desc
          Break
        EndIf
      Next
    Else
      If strucinterf()\ShortDesc And Desc
        PrintN("Warning: You overwrite a documentation of the structure/interface "+strucinterf()\lcName)
        strucinterf()\ShortDesc = Desc
      ElseIf Desc
        strucinterf()\ShortDesc = Desc
      EndIf
    EndIf
  EndIf
EndProcedure

;** FillTargetGlobalVar
;* adds a description to a global variable
;** .Target: target like "g varname"
;** .Desc: the description for the global variable
Procedure FillTargetGlobalVar(Target.s, Desc.s)
  Protected lcGlobName.s, found.l, GlobName.s
  
  Target = Trim(Right(Target, Len(Target) - 2))
  GlobName = Trim(StringField(Target, 1, "."))
  lcGlobName = LCase(GlobName)
  
  If ValidElement(lcGlobName)
    found = #False
    ForEach globalvar()
      If globalvar()\lcName = lcGlobName And globalvar()\FileName = glob\CurrentFileName
        found = #True
        Break
      EndIf
    Next
    
    If Not found
      AddElement(globalvar())
      globalvar()\lcName = lcGlobName
      globalvar()\FileName = glob\CurrentFileName
    EndIf
    
    If globalvar()\ShortDesc And Desc
      PrintN("Warning: You overwrite a documentation of the global variable "+globalvar()\lcName)
      globalvar()\ShortDesc = Desc
    ElseIf Desc
      globalvar()\ShortDesc = Desc
    EndIf
  EndIf
EndProcedure

;** filltargetconstant
;* adds a description to a constant
Procedure FillTargetConstant(Target.s, Desc.s)
  
  Target = Trim(LCase(Target))
  If Left(Target, 2) = "c "
    Target = Trim(Right(Target, Len(Target) - 2))
  EndIf
  
  If ValidElement(Trim(Right(Target, Len(Target) - 1)))
    ForEach constant()
      If constant()\lcName = Target And constant()\FileName = glob\CurrentFileName
        If constant()\Desc And Desc
          PrintN("Warning: You overwrite a documentation of the constant "+Target)
          constant()\Desc = Desc
        ElseIf Desc
          constant()\Desc = Desc
        EndIf
        ProcedureReturn 0
      EndIf
    Next
    
    AddElement(constant())
    constant()\FileName = glob\CurrentFileName
    constant()\lcName = Target
    constant()\Desc = Desc
  EndIf
EndProcedure

;** AddFunction: adds a function to the function list
;** .FuncName: Name of function
;** .FuncLine: The function with its parameters: func.s(a.l, b.c)
Procedure AddFunction(List params.PARAM(), FuncName.s, FuncLine.s, Export.l, Desc.s)
  Protected lcFuncName.s, found.l, z.l
  
  lcFuncName = LCase(FuncName)
  
  If ValidElement(lcFuncName)
    found = #False
    ForEach function()
      If function()\lcName = lcFuncName And function()\FileName = glob\CurrentFileName
        found = #True
        Break
      EndIf
    Next
    
    If Not found
      AddElement(function())
      function()\FileName = glob\CurrentFileName
      function()\lcName = lcFuncName
    EndIf
    
    function()\Name = FuncName
    function()\Line = FuncLine
    function()\Export = Export
    
    If function()\ShortDesc And Desc
      PrintN("Warning: You overwrite the description of the function "+function()\Name+".")
      function()\ShortDesc = Desc
    ElseIf Not Bool(function()\ShortDesc)
      function()\ShortDesc = Desc
    EndIf
    
    ForEach params()
      For z = 0 To #MAX_PARAMETERS-1
        With function()\Params[z]
          If \lcName = params()\lcName
            \Name = params()\Name
            Break
          ElseIf \lcName = ""
            \Name = params()\Name
            \lcName = params()\lcName
            Break
          EndIf
        EndWith
      Next
    Next
  EndIf
EndProcedure

;** AddStrucInterf
;* Adds a structure or interface to the list
;** .name: the name
;** .Parent: the extended structure
;** .elements: all elements of the structure/interface
Procedure AddStrucInterf(Name.s, Parent.s, List elements.ELEMS())
  Protected lcName.s, found.l, z.l
  
  lcName = LCase(Name)
  If ValidElement(lcName)
    found = #False
    ForEach strucinterf()
      If strucinterf()\lcName = lcName And strucinterf()\FileName = glob\CurrentFileName
        found = #True
        Break
      EndIf
    Next
    
    If Not found
      AddElement(strucinterf())
      strucinterf()\FileName = glob\CurrentFileName
      strucinterf()\lcName = lcName
    EndIf
    
    strucinterf()\Name = Name
    strucinterf()\lcName = LCase(Name)
    strucinterf()\Parent = Parent
    
    ForEach elements()
      For z = 0 To #MAX_ELEMENTS-1
        With strucinterf()\Elems[z]
          If \lcName = elements()\lcName
            \Name = elements()\Name
            \Line = elements()\Line
            
            If elements()\Desc And \Desc
              PrintN("Warning: You overwrite a documentation of the element " + \Name)
              \Desc = elements()\Desc
            ElseIf elements()\Desc
              \Desc = elements()\Desc
            EndIf
            Break
            
          ElseIf \lcName = ""
            \Name = elements()\Name
            \lcName = elements()\lcName
            \Line = elements()\Line
            
            If elements()\Desc And \Desc
              PrintN("Warning: You overwrite a documentation of the element " + \Name)
              \Desc = elements()\Desc
            ElseIf elements()\Desc
              \Desc = elements()\Desc
            EndIf
            Break
          EndIf
        EndWith
      Next
    Next
  EndIf
EndProcedure

;** addglobalvar
;* adds a global var to the list of global vars
;** .Name: name of the global variable
;** .Line: name with type specification: a.l
Procedure AddGlobalVar(Name.s, Line.s, Desc.s)
  Protected lcName.s
  
  lcName = LCase(Name)
  If ValidElement(lcName)
    ForEach globalvar()
      If globalvar()\lcName = lcName And globalvar()\FileName = glob\CurrentFileName
        globalvar()\Name = Name
        globalvar()\Line = Line
        If globalvar()\ShortDesc And Desc
          PrintN("Warning: You have overwritten the description for the global variable "+globalvar()\Name+".")
          globalvar()\ShortDesc = Desc
        ElseIf Not Bool(globalvar()\ShortDesc)
          globalvar()\ShortDesc = Desc
        EndIf
        ProcedureReturn 0
      EndIf
    Next
    
    AddElement(globalvar())
    globalvar()\FileName = glob\CurrentFileName
    globalvar()\Name = Name
    globalvar()\lcName = lcName
    globalvar()\Line = Line
    globalvar()\ShortDesc = Desc
  EndIf
EndProcedure

;** AddConstant: Adds a constant to the list
Procedure AddConstant(Name.s, Desc.s)
  Protected lcName.s
  
  lcName = LCase(Name)
  If ValidElement(Trim(Right(lcName, Len(lcName) - 1)))
    ForEach constant()
      If constant()\lcName = lcName And constant()\FileName = glob\CurrentFileName
        constant()\Name = Name
        
        If Desc And constant()\Desc
          PrintN("Warning: You overwrite a documentation of the constant " + Name)
          constant()\Desc = Desc
        ElseIf Desc
          constant()\Desc = Desc
        EndIf
        ProcedureReturn 0
      EndIf
    Next
    
    AddElement(constant())
    constant()\FileName = glob\CurrentFileName
    constant()\Name = Name
    constant()\lcName = lcName
    constant()\Desc = Desc
  EndIf
EndProcedure

;** processprocedureline
;* parses the line starting with 'procedure' or 'macro'
Procedure ProcessProcedureLine()
  Protected FuncName.s, FuncLine.s, RetType.s, Parenthesis.l, FoundParam.l, z.l, Export.l, Desc.s
  NewList params.PARAM()
  
  If LCase(token()\s) = "proceduredll" Or LCase(token()\s) = "procedurecdll"
    Export = #True
  EndIf
  If NextElement(token()) And token()\s = "."
    If NextElement(token())
      RetType = token()\s
      NextElement(token())
      FuncName = token()\s
      FuncLine = FuncName + "." + RetType
    EndIf
  Else
    FuncName = token()\s
    FuncLine = FuncName
  EndIf
  
  If NextElement(token()) And token()\s = "("
    Parenthesis = 1
    FuncLine + token()\s
  EndIf
  
  FoundParam = 0
  While Parenthesis > 0 And NextElement(token())
    FuncLine + token()\s
    If token()\s = "("
      Parenthesis + 1
    ElseIf token()\s = ")"
      Parenthesis - 1
    ElseIf token()\s = ","
      FoundParam = 0
    EndIf
    If token()\Type = #PBSC_Identifier And FoundParam = 0
      AddElement(params())
      params()\Name = token()\s
      params()\lcName = LCase(params()\Name)
      FoundParam = 1
    EndIf
  Wend
  
  Desc = ""
  If NextElement(token()) And token()\Type = #PBSC_Comment And Left(token()\s, 2) = ";*"
    Desc = Trim(Right(token()\s, Len(token()\s) - 2))
  EndIf
  
  If Export = #True Or glob\FilterOnlyDLLs = #False
    AddFunction(params(), FuncName, FuncLine, Export, PreProcessHTMLLine(Desc))
  EndIf
EndProcedure

;** processincludeline
;* parses (x)include lines
Procedure ProcessIncludeLine()
  Protected Name.s, Path.s, lcPath.s
  
  If NextElement(token()) And token()\Type = #PBSC_String
    Path = Mid(token()\s, 2, Len(token()\s) - 2)
    Name = GetFilePart(Path)
    lcPath = LCase(Path)
    
    ForEach include()
      If include()\lcPath = lcPath And include()\FileName = glob\CurrentFileName
        ProcedureReturn 0
      EndIf
    Next
    
    AddElement(include())
    include()\FileName = glob\CurrentFileName
    include()\lcPath = lcPath
    include()\Path = Path
    include()\Name = Name
    
  EndIf
EndProcedure

;** processglobalsline
;* parses a line with global variables
Procedure ProcessGlobalsLine()
  Protected Name.s, Line.s, Desc.s, Stop.l
  
  While (Not Stop) And NextElement(token()) And token()\Type = #PBSC_Identifier And LCase(token()\s) <> "global"
    If LCase(token()\s) = "newlist" Or LCase(token()\s) = "dim" Or LCase(token()\s) = "newmap"
      If Not NextElement(token())
        Break
      EndIf
    EndIf
    
    Name = token()\s
    Line = Name
    
    Desc = ""
    While NextElement(token())
      If token()\s = ","
        Break
      ElseIf token()\Type = #PBSC_NewLine
        Stop = #True
        Break
      ElseIf token()\Type = #PBSC_Comment
        Stop = #True
        Desc = Trim(token()\s)
        If Left(Desc, 2) = ";*"
          Desc = Trim(Right(Desc, Len(Desc) - 2))
        Else
          Desc = ""
        EndIf
        
        Break
      Else
        Line + token()\s
      EndIf
    Wend
    
    AddGlobalVar(Name.s, Line.s, PreProcessHTMLLine(Desc.s))
  Wend
  
  PreviousElement(token())
EndProcedure

;** processstrucinterf
;* parses a structure or interface block with its elements
Procedure ProcessStrucInterf()
  Protected Name.s, Parent.s
  NewList elements.ELEMS()
  
  If NextElement(token()) And token()\Type = #PBSC_Identifier
    Name = token()\s
  Else
    ProcedureReturn 0
  EndIf
  
  If NextElement(token()) And LCase(token()\s) = "extends" And NextElement(token())
    Parent = token()\s
    If Not NextElement(token())
      ProcedureReturn 0
    EndIf
  EndIf
  ; token = newline
  
  While NextElement(token()) And LCase(token()\s) <> "endstructure" And LCase(token()\s) <> "endinterface"
    
    If token()\Type = #PBSC_Identifier
      AddElement(elements())
      elements()\Name = token()\s
      elements()\lcName = LCase(token()\s)
      elements()\Line = token()\s
      
      While NextElement(token()) And token()\Type <> #PBSC_NewLine And token()\s <> ":"
        If token()\Type = #PBSC_Comment 
          If Left(token()\s, 2) = ";*"
            elements()\Desc = PreProcessHTMLLine(Trim(Right(token()\s, Len(token()\s) - 2)))
          EndIf
        Else
          elements()\Line + token()\s
        EndIf
      Wend
    EndIf
    
  Wend
  
  AddStrucInterf(Name.s, Parent.s, elements())
EndProcedure

;** processconstantline
;* parses a line with a constant
Procedure ProcessConstantLine()
  Protected Name.s, *currentElement, foundComment.l, Desc.s
  
  Name = token()\s
  *currentElement = @token()
  If PreviousElement(token()) And token()\Type <> #PBSC_NewLine
    ChangeCurrentElement(token(), *currentElement)
    ProcedureReturn 0
  EndIf
  ChangeCurrentElement(token(), *currentElement)
  
  While NextElement(token()) And token()\Type <> #PBSC_NewLine And token()\s <> ":"
    If token()\Type = #PBSC_Comment And Left(token()\s, 2) = ";*"
      foundComment = #True
      Desc = Trim(Right(token()\s, Len(token()\s) - 2))
      Break
    EndIf
  Wend
  
  AddConstant(Name, PreProcessHTMLLine(Desc))
  If Not foundComment
    ChangeCurrentElement(token(), *currentElement)
  EndIf
EndProcedure

;** processcommentparameters
;* will read parameters in comments.
Procedure.l ProcessCommentParameters(Comment.s)
  Protected pos1.l, pos2.l, Parameter.s, What.s, DidNot.l
  
  pos1 = FindString(Comment, "/", 1)
  pos2 = FindString(Comment, " ", pos1)
  If pos2 = 0 : pos2 = Len(Comment) : EndIf
  
  Parameter = Trim(Mid(Comment, pos1, pos2 - pos1 + 1))
  What = Trim(Mid(Comment, pos2, Len(Comment) - pos2 + 1))
  
  If ProcessProgramParameter(parameter, What, #True) <> ""
    DidNot = #True
  EndIf
;   Select Parameter
;     Case "/notstart"
;       glob\FilterNotStartWith = What
;     Case "/onlystart"
;       glob\FilterStartWith = What
;     Case "/onlydll"
;       glob\FilterOnlyDLLs = #True
;     Case "/nodlltable"
;       glob\FilterNoDLLTable = #True
;     Case "/nofunctions"
;       glob\FilterNoFunctions = #True
;     Case "/noglobals"
;       glob\FilterNoGlobals = #True
;     Case "/nostructs"
;       glob\FilterNoStructs = #True
;     Case "/noconstants"
;       glob\FilterNoConstants = #True
;     Default
;       DidNot = #True
;   EndSelect
  
  If DidNot
    ProcedureReturn #False
  EndIf
  ProcedureReturn #True
EndProcedure

;** processfile: starts parsing of the loaded file
Procedure.l ProcessFile()
  Protected CurrentTarget.s, CurrentComment.s, lcToken.s, LastTarget.s
  Protected isStruc.l, EndIt.l, p.l
  
  CurrentTarget = "--------------------"
  ForEach token()
    lcToken = LCase(token()\s)
    If token()\Type = #PBSC_Comment
      If Left(lcToken, 3) = ";**" And Left(Trim(StringField(lcToken, 3, "*")), 1) = "/" And ProcessCommentParameters(lcToken)
        ; do nothing more :)
      ElseIf Left(lcToken, 3) = ";**"
        If CurrentTarget <> "--------------------"
          CheckCurrentTarget:
          If CurrentTarget = ""
            AddElement(filedesc())
            filedesc()\FileName = glob\CurrentFileName
            filedesc()\FileDesc = CurrentComment
            
          ElseIf LCase(Left(CurrentTarget, 2)) = "g "
            FillTargetGlobalVar(CurrentTarget, CurrentComment)
            
          ElseIf LCase(Left(CurrentTarget, 2)) = "s " Or LCase(Left(CurrentTarget, 2)) = "i "
            If Mid(CurrentTarget, 3, 1) = "."
              FillTargetStructure("s " + LastTarget + Right(CurrentTarget, Len(CurrentTarget) - 2), CurrentComment)
            Else
              LastTarget = Right(CurrentTarget, Len(CurrentTarget) - 2)
              LastTarget = LCase(Trim(StringField(LastTarget, 1, ".")))
              isStruc = #True
              FillTargetStructure(CurrentTarget, CurrentComment)
            EndIf
            
          ElseIf Left(CurrentTarget, 1) = "."
            If isStruc
              FillTargetStructure("s " + LastTarget + CurrentTarget, CurrentComment)
            Else
              FillTargetFunction(LastTarget + CurrentTarget, CurrentComment)
            EndIf
            
          ElseIf LCase(Left(CurrentTarget, 2)) = "c " Or Left(CurrentTarget, 1) = "#"
            FillTargetConstant(CurrentTarget, CurrentComment)
            
          Else
            isStruc = #False
            LastTarget = StringField(LCase(CurrentTarget), 1, ".")
            FillTargetFunction(CurrentTarget, CurrentComment)
            
          EndIf
          If EndIt
            ProcedureReturn #True
          EndIf
        EndIf
        
        CurrentTarget = Trim(Right(token()\s, Len(token()\s) - 3))
        p = FindString(CurrentTarget, ":", 1)
        If p
          CurrentComment = PreProcessHTMLLine(Trim(Mid(CurrentTarget, p + 1, Len(CurrentTarget) - p)))
          CurrentTarget = Trim(Mid(CurrentTarget, 1, p - 1))
        Else
          CurrentComment = ""
        EndIf
        
      ElseIf Left(token()\s, 2) = ";*"
        CurrentComment + PreProcessHTMLLine(Trim(Right(token()\s, Len(token()\s) - 2))) + " "
      EndIf
      
    ElseIf lcToken = "procedure" Or lcToken = "macro" Or lcToken = "proceduredll" Or lcToken = "procedurecdll"
      ProcessProcedureLine()
      
    ElseIf lcToken = "includefile" Or lcToken = "xincludefile"
      ProcessIncludeLine()
      
    ElseIf lcToken = "global"
      ProcessGlobalsLine()
      
    ElseIf lcToken = "structure" Or lcToken = "interface"
      ProcessStrucInterf()
      
    ElseIf token()\Type = #PBSC_Identifier And Left(lcToken, 1) = "#"
      ProcessConstantLine()
      
    EndIf
  Next
  
  If CurrentTarget <> "--------------------"
    EndIt = #True
    Goto CheckCurrentTarget
  EndIf
  
  ProcedureReturn #True
EndProcedure

;** getfiledescription
;* returns the html-string with the file desc.
Procedure.s GetFileDescription()
  Protected STemplate.s
  
  STemplate = "<P><DL><DT><H2><a Name="+#DQUOTE$+"file_description"+#DQUOTE$+">Description</a></H2></DT>"
  STemplate + "<DD>%FILEDESCRIPTION%</DD></DL>"
  STemplate + "<br><a href="+#DQUOTE$+"#top"+#DQUOTE$+">Top</a>, <a href="+#DQUOTE$+"javascript:history.back()"+#DQUOTE$+">Back</a></p><hr>"
  
  ForEach filedesc()
    If glob\CurrentFileName = filedesc()\FileName
      ProcedureReturn ReplaceString(STemplate, "%FILEDESCRIPTION%", filedesc()\FileDesc)
    EndIf
  Next
  ; no description available
  ProcedureReturn ""
EndProcedure

;** getincludefiles
;* returns the html-string with the table for include files
Procedure.s GetIncludeFiles()
  Protected Template.s, Result.s, Temp.s
  
  SortStructuredList(include(), 2, OffsetOf(INCLUDE\Name), #PB_String)
  Template = "<A HREF="+#DQUOTE$+"%PATH%"+#DQUOTE$+" >%NAME%</A>"
  
  
  ForEach include()
    If include()\FileName = glob\CurrentFileName
      Temp = ReplaceString(Template, "%PATH%", GetFilePart(include()\Path) + ".html")
      Temp = ReplaceString(Temp, "%NAME%", include()\Name)
      Result + Temp + ", "
    EndIf
  Next
  
  ProcedureReturn Left(Result, Len(Result) - 2)
EndProcedure

;** getincludedin
;* returns the html-string with the table included-in-files
Procedure.s GetIncludedIn()
  Protected Template.s, Result.s, Temp.s
  NewList includedin.String()
  
  ForEach include()
    If include()\Name = glob\CurrentFileName
      AddElement(includedin())
      includedin()\s = include()\FileName
    EndIf
  Next
  
  SortStructuredList(includedin(), 2, OffsetOf(String\s), #PB_String)
  Template = "<A HREF="+#DQUOTE$+"%PATH%"+#DQUOTE$+" >%NAME%</A>"
  
  ForEach includedin()
    Temp = ReplaceString(Template, "%PATH%", GetFilePart(includedin()\s) + ".html")
    Temp = ReplaceString(Temp, "%NAME%", includedin()\s)
    Result + Temp + ", "
  Next
  
  ProcedureReturn Left(Result, Len(Result) - 2)
EndProcedure

;** getglobalsoverview
;* returns the html-table of globals - overview
Procedure.s GetGlobalsOverview()
  Protected Template.s, Result.s, Temp.s, STemplate.s, AddedOne.l
  
  STemplate = "<P><TABLE BORDER="+#DQUOTE$+"1"+#DQUOTE$+" WIDTH="+#DQUOTE$+"100%"+#DQUOTE$+" CELLPADDING="+#DQUOTE$+"3"+#DQUOTE$+" CELLSPACING="+#DQUOTE$+"0"+#DQUOTE$+">"
  STemplate + "<TR BGCOLOR="+#DQUOTE$+"#CCCCFF"+#DQUOTE$+"><TH ALIGN="+#DQUOTE$+"left"+#DQUOTE$+" COLSPAN="+#DQUOTE$+"2"+#DQUOTE$+"><FONT Size="+#DQUOTE$+"+2"+#DQUOTE$+"><b><a Name="+#DQUOTE$+"global_variables_overview"+#DQUOTE$+">Global Variables</a></b></FONT></TH></TR>"
  STemplate + "%GLOBALVARSOVERVIEW%"
  STemplate + "</TABLE><br><a href="+#DQUOTE$+"#top"+#DQUOTE$+">Top</a>, <a href="+#DQUOTE$+"javascript:history.back()"+#DQUOTE$+">Back</a></p><hr>"
  
  If Not (glob\FilterNoSort)
    SortStructuredList(globalvar(), 2, OffsetOf(GLOBALVARS\Name), #PB_String)
  EndIf
  Template = "<TR BGCOLOR="+#DQUOTE$+"white"+#DQUOTE$+"><TD><DL><DT>"
  Template + "<code><b>%LINE%</b></code></DT><DD>%SHORTDESC%</DD><DL></TD></TR>"
  
  ForEach globalvar()
    If globalvar()\FileName = glob\CurrentFileName
      Temp = ReplaceString(Template, "%LINE%", RestyleCode(globalvar()\Line))
      Temp = ReplaceString(Temp, "%SHORTDESC%", globalvar()\ShortDesc)
      Result + Temp + #CRLF$
      AddedOne = #True
    EndIf
  Next
  
  If Not AddedOne
    ProcedureReturn ""
  EndIf
  
  ProcedureReturn ReplaceString(STemplate, "%GLOBALVARSOVERVIEW%", Result)
EndProcedure

;** getconstantsoverview
;* returns the html-table of constants - overview
Procedure.s GetConstantsOverview()
  Protected Template.s, Result.s, Temp.s, STemplate.s, AddedOne.l
  
  STemplate = "<P><TABLE BORDER="+#DQUOTE$+"1"+#DQUOTE$+" WIDTH="+#DQUOTE$+"100%"+#DQUOTE$+" CELLPADDING="+#DQUOTE$+"3"+#DQUOTE$+" CELLSPACING="+#DQUOTE$+"0"+#DQUOTE$+">"
  STemplate + "<TR BGCOLOR="+#DQUOTE$+"#CCCCFF"+#DQUOTE$+"><TH ALIGN="+#DQUOTE$+"left"+#DQUOTE$+" COLSPAN="+#DQUOTE$+"2"+#DQUOTE$+"><FONT Size="+#DQUOTE$+"+2"+#DQUOTE$+">"
  STemplate + "<b><a Name="+#DQUOTE$+"constants"+#DQUOTE$+">Constants</a></b></FONT></TH></TR>"
  STemplate + "%CONSTANTS%</TABLE><br>"
  STemplate + "<a href="+#DQUOTE$+"#top"+#DQUOTE$+">Top</a>, <a href="+#DQUOTE$+"javascript:history.back()"+#DQUOTE$+">Back</a></p><hr>"
  
  If Not (glob\FilterNoSort)
    SortStructuredList(constant(), 2, OffsetOf(CONSTANT\Name), #PB_String)
  EndIf
  Template = "<TR BGCOLOR="+#DQUOTE$+"white"+#DQUOTE$+"><TD><DL><DT>"
  Template + "<code><b>%NAME%</b></code></DT><DD>%DESC%</DD><DL></TD></TR>"
  
  ForEach constant()
    If constant()\FileName = glob\CurrentFileName
      If constant()\Name
        Temp = ReplaceString(Template, "%NAME%", constant()\Name)
        Temp = ReplaceString(Temp, "%DESC%", constant()\Desc)
        Result + Temp + #CRLF$
        AddedOne = #True
      Else
        PrintN("Warning: The constant "+constant()\lcName+" is not defined in your source, but you documented it!")
      EndIf
    EndIf
  Next
  
  If Not AddedOne
    ProcedureReturn ""
  EndIf
  
  ProcedureReturn ReplaceString(STemplate, "%CONSTANTS%", Result)
EndProcedure

;** getallfunctionsoverview
;* returns the html-table of all functions - overview
Procedure.s GetAllFunctionsOverview()
  Protected Template.s, Result.s, Temp.s, Temp2.s, s1.l, s2.l, STemplate.s
  Protected AddedOne.l
  
  STemplate = "<P><TABLE BORDER="+#DQUOTE$+"1"+#DQUOTE$+" WIDTH="+#DQUOTE$+"100%"+#DQUOTE$+" CELLPADDING="+#DQUOTE$+"3"+#DQUOTE$+" CELLSPACING="+#DQUOTE$+"0"+#DQUOTE$+">"
  STemplate + "<TR BGCOLOR="+#DQUOTE$+"#CCCCFF"+#DQUOTE$+">"
  STemplate + "<TH ALIGN="+#DQUOTE$+"left"+#DQUOTE$+" COLSPAN="+#DQUOTE$+"2"+#DQUOTE$+"><FONT Size="+#DQUOTE$+"+2"+#DQUOTE$+"><b><a Name="+#DQUOTE$+"functions_overview"+#DQUOTE$+">Functions and Macros</a></b></FONT></TH></TR>"
  STemplate + "%FUNCTIONSOVERVIEW%"
  STemplate + "</TABLE><br><a href="+#DQUOTE$+"#top"+#DQUOTE$+">Top</a>, <a href="+#DQUOTE$+"javascript:history.back()"+#DQUOTE$+">Back</a></p><hr>"
  
  If Not (glob\FilterNoSort)
    SortStructuredList(function(), 2, OffsetOf(FUNCTION\Name), #PB_String)
  EndIf
  Template = "<TR BGCOLOR="+#DQUOTE$+"white"+#DQUOTE$+"><TD><DL><DT>"
  Template + "<code><b><a HREF="+#DQUOTE$+"#f_%NAME%"+#DQUOTE$+">%LINELINK%</a>%LINENOTLINK%</b></code></DT>"
  Template + "<DD>%SHORTDESC%</DD><DL></TD></TR>"
  
  
  ForEach function()
    If function()\FileName = glob\CurrentFileName
      If function()\Name
        Temp2 = RestyleCode(function()\Line)
        Temp = ReplaceString(Template, "%LINELINK%", function()\Name)
        Temp = ReplaceString(Temp, "%LINENOTLINK%", Right(Temp2, Len(Temp2) - Len(function()\Name)))
        
        s1 = FindString(function()\ShortDesc, ".", 1)
        s2 = FindString(LCase(function()\ShortDesc), "<br>", 1)
        If (s1 = 0 And s2 <> 0) Or (s2 < s1 And s2 <> 0)
          Temp = ReplaceString(Temp, "%SHORTDESC%", Trim(Mid(function()\ShortDesc, 1, s2 - 1)))
        ElseIf (s2 = 0 And s1 <> 0) Or (s1 < s2 And s1 <> 0)
          Temp = ReplaceString(Temp, "%SHORTDESC%", Trim(Mid(function()\ShortDesc, 1, s1)))
        Else
          Temp = ReplaceString(Temp, "%SHORTDESC%", function()\ShortDesc)
        EndIf
        
        Temp = ReplaceString(Temp, "%NAME%", function()\lcName)
        Result + Temp + #CRLF$
        AddedOne = #True
      Else
        PrintN("Warning: The function/macro "+function()\lcName+" is not defined in your source, but you documented it!")
      EndIf
    EndIf
  Next
  
  If Not AddedOne
    ProcedureReturn ""
  EndIf
  
  ProcedureReturn ReplaceString(STemplate, "%FUNCTIONSOVERVIEW%", Result)
EndProcedure

;** getdllfunctionsoverview
;* returns a html-table of all exported functions
Procedure.s GetDLLFunctionsOverview()
  Protected Template.s, Result.s, Temp.s, Temp2.s, s1.l, s2.l, STemplate.s
  Protected AddedOne.l
  
  STemplate = "<P><TABLE BORDER="+#DQUOTE$+"1"+#DQUOTE$+" WIDTH="+#DQUOTE$+"100%"+#DQUOTE$+" CELLPADDING="+#DQUOTE$+"3"+#DQUOTE$+" CELLSPACING="+#DQUOTE$+"0"+#DQUOTE$+">"
  STemplate + "<TR BGCOLOR="+#DQUOTE$+"#CCCCFF"+#DQUOTE$+">"
  STemplate + "<TH ALIGN="+#DQUOTE$+"left"+#DQUOTE$+" COLSPAN="+#DQUOTE$+"2"+#DQUOTE$+"><FONT Size="+#DQUOTE$+"+2"+#DQUOTE$+"><b><a Name="+#DQUOTE$+"dll_functions_overview"+#DQUOTE$+">Exported Functions</a></b></FONT></TH></TR>"
  STemplate + "%FUNCTIONSOVERVIEW%"
  STemplate + "</TABLE><br><a href="+#DQUOTE$+"#top"+#DQUOTE$+">Top</a>, <a href="+#DQUOTE$+"javascript:history.back()"+#DQUOTE$+">Back</a></p><hr>"
  
  If Not (glob\FilterNoSort)
    SortStructuredList(function(), 2, OffsetOf(FUNCTION\Name), #PB_String)
  EndIf
  Template = "<TR BGCOLOR="+#DQUOTE$+"white"+#DQUOTE$+"><TD><DL><DT>"
  Template + "<code><b><a HREF="+#DQUOTE$+"#f_%NAME%"+#DQUOTE$+">%LINELINK%</a>%LINENOTLINK%</b></code></DT>"
  Template + "<DD>%SHORTDESC%</DD><DL></TD></TR>"
  
  
  ForEach function()
    If function()\Export And function()\FileName = glob\CurrentFileName
      If function()\Name
        Temp2 = RestyleCode(function()\Line)
        Temp = ReplaceString(Template, "%LINELINK%", function()\Name)
        Temp = ReplaceString(Temp, "%LINENOTLINK%", Right(Temp2, Len(Temp2) - Len(function()\Name)))
        
        s1 = FindString(function()\ShortDesc, ".", 1)
        s2 = FindString(LCase(function()\ShortDesc), "<br>", 1)
        If (s1 = 0 And s2 <> 0) Or (s2 < s1 And s2 <> 0)
          Temp = ReplaceString(Temp, "%SHORTDESC%", Trim(Mid(function()\ShortDesc, 1, s2 - 1)))
        ElseIf (s2 = 0 And s1 <> 0) Or (s1 < s2 And s1 <> 0)
          Temp = ReplaceString(Temp, "%SHORTDESC%", Trim(Mid(function()\ShortDesc, 1, s1)))
        Else
          Temp = ReplaceString(Temp, "%SHORTDESC%", function()\ShortDesc)
        EndIf
        
        Temp = ReplaceString(Temp, "%NAME%", function()\lcName)
        Result + Temp + #CRLF$
        AddedOne = #True
      Else
        PrintN("Warning: The function/macro "+function()\lcName+" is not defined in your source, but you documented it!")
      EndIf
    EndIf
  Next
  
  If Not AddedOne
    ProcedureReturn ""
  EndIf
  
  ProcedureReturn ReplaceString(STemplate, "%FUNCTIONSOVERVIEW%", Result)
EndProcedure

;** getstructinterfoverview
;* returns a html-string with a table of an overview of structures and interfaces
Procedure.s GetStructInterfOverview()
  Protected Template.s, Result.s, Temp.s, s1.l, s2.l, STemplate.s, AddedOne.l
  
  STemplate = "<P><TABLE BORDER="+#DQUOTE$+"1"+#DQUOTE$+" WIDTH="+#DQUOTE$+"100%"+#DQUOTE$+" CELLPADDING="+#DQUOTE$+"3"+#DQUOTE$+" CELLSPACING="+#DQUOTE$+"0"+#DQUOTE$+">"
  STemplate + "<TR BGCOLOR="+#DQUOTE$+"#CCCCFF"+#DQUOTE$+"><TH ALIGN="+#DQUOTE$+"left"+#DQUOTE$+" COLSPAN="+#DQUOTE$+"2"+#DQUOTE$+"><FONT Size="+#DQUOTE$+"+2"+#DQUOTE$+"><b><a Name="+#DQUOTE$+"interface_structure_overview"+#DQUOTE$+">Structures and Interfaces</a></b></FONT></TH></TR>"
  STemplate + "%STRUCINTEROVERVIEW%"
  STemplate + "</TABLE><br><a href="+#DQUOTE$+"#top"+#DQUOTE$+">Top</a>, <a href="+#DQUOTE$+"javascript:history.back()"+#DQUOTE$+">Back</a></p><hr>"
  
  If Not (glob\FilterNoSort)
    SortStructuredList(strucinterf(), 2, OffsetOf(STRUCT_INTERF\Name), #PB_String)
  EndIf
  Template = "<TR BGCOLOR="+#DQUOTE$+"white"+#DQUOTE$+"><TD><DL><DT>"
  Template + "<code><b><a HREF="+#DQUOTE$+"#s_%LCNAME%"+#DQUOTE$+">%NAME%</a>%PARENT%</b></code>"
  Template + "</DT><DD>%SHORTDESC%</DD><DL></TD></TR>"
  
  ForEach strucinterf()
    If strucinterf()\FileName = glob\CurrentFileName
      If strucinterf()\Name
        s1 = FindString(strucinterf()\ShortDesc, ".", 1)
        s2 = FindString(LCase(strucinterf()\ShortDesc), "<br>", 1)
        If (s1 = 0 And s2 <> 0) Or s2 < s1
          Temp = ReplaceString(Template, "%SHORTDESC%", Trim(Mid(strucinterf()\ShortDesc, 1, s2 - 1)))
        ElseIf (s2 = 0 And s1 <> 0) Or s1 < s2
          Temp = ReplaceString(Template, "%SHORTDESC%", Trim(Mid(strucinterf()\ShortDesc, 1, s1)))
        Else
          Temp = ReplaceString(Template, "%SHORTDESC%", strucinterf()\ShortDesc)
        EndIf
        
        Temp = ReplaceString(Temp, "%LCNAME%", strucinterf()\lcName)
        Temp = ReplaceString(Temp, "%NAME%", strucinterf()\Name)
        If strucinterf()\Parent
          Temp = ReplaceString(Temp, "%PARENT%", RestyleCode(" extends " + strucinterf()\Parent))
        Else
          Temp = ReplaceString(Temp, "%PARENT%", "")
        EndIf
        Result + Temp + #CRLF$
        AddedOne = #True
      Else
        PrintN("Warning: The structure/interface "+strucinterf()\lcName+" is not declared in your source, but you documented it!")
      EndIf
    EndIf
  Next
  
  If Not AddedOne
    ProcedureReturn ""
  EndIf
  
  ProcedureReturn ReplaceString(STemplate, "%STRUCINTEROVERVIEW%", Result)
EndProcedure

;** getfunctionsdetailslist
;* returns html-string of detailed long-description list of functions/macros
Procedure.s GetFunctionsDetailsList()
  Protected Template.s, Result.s, Temp.s, z.l, Temp2.s
  
  ForEach function()
    If ((glob\FilterOnlyDLLs And function()\Export) Or glob\FilterOnlyDLLs = #False) And function()\FileName = glob\CurrentFileName
      If function()\Name
        Temp2 = RestyleCode(function()\Line)
        Temp = "<p><dl><dt><H3><A name="+#DQUOTE$+"f_"+function()\lcName+#DQUOTE$+">"+Temp2+"</A></H3></dt>"
        Temp + "<dd>" + function()\ShortDesc + "</dd>"
        
        If function()\Params[0]\lcName Or function()\Params[#MAX_PARAMETERS-1]\lcName
          Dim array_.PARAM(#MAX_PARAMETERS-1)
          CopyMemory(@function()\Params[0], @array_(), #MAX_PARAMETERS * SizeOf(PARAM))
          
          If Not (glob\FilterNoSortParam Or glob\FilterNoSortPaFl Or glob\FilterNoSort)
            SortStructuredArray(array_(), 2, OffsetOf(PARAM\Name), #PB_String)
          EndIf
          
          
          CopyMemory(@array_(), @function()\Params[0], #MAX_PARAMETERS * SizeOf(PARAM))
          ResetArray(@array_(), SizeOf(PARAM) * #MAX_PARAMETERS)
          
          Temp + "<dl><dt><H4>Parameters:</H4></dt>"
          For z = 0 To #MAX_PARAMETERS-1
            If function()\Params[z]\lcName
              If function()\Params[z]\Name
                Temp + "<dd><dl><dt>"+function()\Params[z]\Name+"</dt><dd>"+function()\Params[z]\Desc+"</dd></dl></dd>"
              Else
                PrintN("Warning: The parameter "+function()\Params[z]\lcName+" of the function/macro "+function()\Name+" is not declared in your source, but you documented it!")
              EndIf
            EndIf
          Next
          Temp + "</dl>"
        EndIf
        Temp + "</dl><br><A href="+#DQUOTE$+"#top"+#DQUOTE$+">Top</a>, <a href="+#DQUOTE$+"javascript:history.back()"+#DQUOTE$+">Back</a></p><hr>"
        Result + Temp + #CRLF$
      EndIf
    EndIf
  Next
  
  ProcedureReturn Result
EndProcedure

;** getstrucinterfdetailslist
;* returns html-string of details of structures and interfaces
Procedure.s GetStrucInterfDetailsList()
  Protected Template.s, Result.s, Temp.s, z.l, Temp2.s
  
  ForEach strucinterf()
    If strucinterf()\FileName = glob\CurrentFileName
      If strucinterf()\Name
        If strucinterf()\Parent
          Temp = RestyleCode(strucinterf()\Name + " extends " + strucinterf()\Parent)
        Else
          Temp = strucinterf()\Name
        EndIf
        
        Temp = "<p><dl><dt><H3><A name="+#DQUOTE$+"s_" + strucinterf()\lcName + #DQUOTE$+">" + Temp + "</A></H3></dt>"
        Temp + "<dd>" + strucinterf()\ShortDesc + "</dd>"
        
        If strucinterf()\Elems[0]\lcName Or strucinterf()\Elems[#MAX_ELEMENTS-1]\lcName
          Dim array_.ELEMS(#MAX_ELEMENTS-1)
          CopyMemory(@strucinterf()\Elems, @array_(), #MAX_ELEMENTS * SizeOf(ELEMS))
          
          If Not (glob\FilterNoSortField Or glob\FilterNoSortPaFl Or glob\FilterNoSort)
            SortStructuredArray(array_(), 2, OffsetOf(ELEMS\Name), #PB_String)
          EndIf
          CopyMemory(@array_(), @strucinterf()\Elems, #MAX_ELEMENTS * SizeOf(ELEMS))
          ResetArray(@array_(), SizeOf(ELEMS) * #MAX_ELEMENTS)
          
          Temp + "<dl><dt><H4>Elements:</H4></dt>"
          For z = 0 To #MAX_ELEMENTS-1
            If strucinterf()\Elems[z]\lcName
              If strucinterf()\Elems[z]\Name
                Temp2 = RestyleCode(strucinterf()\Elems[z]\Line)
                Temp + "<dd><dl><dt>"+Temp2+"</dt><dd>"+strucinterf()\Elems[z]\Desc+"</dd></dl></dd>"
              Else
                PrintN("Warning: The element "+strucinterf()\Elems[z]\lcName+" of the structure/interface "+strucinterf()\Name+" is not declared in your source, but you documented it!")
              EndIf
            EndIf
          Next
          Temp + "</dl>"
        EndIf
        Temp + "</dl><br><A href="+#DQUOTE$+"#top"+#DQUOTE$+">Top</a>, <a href="+#DQUOTE$+"javascript:history.back()"+#DQUOTE$+">Back</a></p><hr>"
        result + Temp + #CRLF$
      EndIf
    EndIf
  Next
  
  ProcedureReturn result
EndProcedure


;** writeoutfile: writes the actual html-file
;** .infilename: source file name
;** .outfilename: file name of file to create and write in
;** .template: the template html-file with placeholders
Procedure.l WriteOutFile(inFileName.s, outFileName.s, Template.s)
  Protected FileID.l, Temp.s, Overview.s
  
  FileID = CreateFile(#PB_Any, outFileName)
  If IsFile(FileID)
    Template = ReplaceString(Template, "%INCLUDEFILES%", GetIncludeFiles())
    Template = ReplaceString(Template, "%INCLUDEDIN%", GetIncludedIn())
    Template = ReplaceString(Template, "%FILENAME%", GetFilePart(inFileName))
    
    If glob\StyleSheet 
      ;<style type="text/css" media="all">@import "style.css";</style>
      Template = ReplaceString(Template, "%STYLESHEET%", "<STYLE type="+#DQUOTE$+"text/css"+#DQUOTE$+" media="+#DQUOTE$+"all"+#DQUOTE$+">@import "+#DQUOTE$+glob\StyleSheet+#DQUOTE$+";</style>")
    Else
      Template = ReplaceString(Template, "%STYLESHEET%", "")
    EndIf
    
    Temp = GetFileDescription()
    If Temp
      Overview + "<li><A HREF="+#DQUOTE$+"#file_description"+#DQUOTE$+">Description</a></li>" + #LF$
    EndIf
    Template = ReplaceString(Template, "%INCLUDEFILEDESCRIPTION%", Temp)
    If Not glob\FilterNoConstants
      Temp = GetConstantsOverview()
      If Temp
        Overview + "<li><a HREF="+#DQUOTE$+"#constants"+#DQUOTE$+">Constants</a></li>" + #LF$
      EndIf
    Else
      Temp = ""
    EndIf
    Template = ReplaceString(Template, "%CONSTANTSDESCRIPTION%", Temp)
    If Not glob\FilterNoStructs
      Temp = GetStructInterfOverview()
      If Temp
        Overview + "<li><a HREF="+#DQUOTE$+"#interface_structure_overview"+#DQUOTE$+">Interfaces and Structures</a></li>" + #LF$
      EndIf
    Else
      Temp = ""
    EndIf
    Template = ReplaceString(Template, "%STRUCINTERFOVERVIEWDESCRIPTION%", Temp)
    If Not glob\FilterNoGlobals
      Temp = GetGlobalsOverview()
      If Temp
        Overview + "<li><a HREF="+#DQUOTE$+"#global_variables_overview"+#DQUOTE$+">Global Variables</a></li>" + #LF$
      EndIf
    Else
      Temp = ""
    EndIf
    Template = ReplaceString(Template, "%GLOBALVARSDESCRIPTION%", Temp)
    If glob\FilterOnlyDLLs = #False And (Not glob\FilterNoFunctions)
      Temp = GetAllFunctionsOverview()
      If Temp
        Overview + "<li><a HREF="+#DQUOTE$+"#functions_overview"+#DQUOTE$+">Functions and Macros</a></li>" + #LF$
      EndIf
    Else
      Temp = ""
    EndIf
    Template = ReplaceString(Template, "%FUNCTIONSOVERVIEWDESCRIPTION%", Temp)
    If (Not glob\FilterNoFunctions) And (Not glob\FilterNoDLLTable)
      Temp = GetDLLFunctionsOverview()
      If Temp
        Overview + "<li><a HREF="+#DQUOTE$+"#dll_functions_overview"+#DQUOTE$+">Exported Functions</a></li>" + #LF$
      EndIf
    Else
      Temp = ""
    EndIf
    Template = ReplaceString(Template, "%DLLFUNCTIONSOVERVIEWDESCRIPTION%", Temp)
    If Not glob\FilterNoFunctions
      Template = ReplaceString(Template, "%FUNCTIONLIST%", GetFunctionsDetailsList())
    Else
      Template = ReplaceString(Template, "%FUNCTIONLIST%", "")
    EndIf
    If Not glob\FilterNoStructs
      Template = ReplaceString(Template, "%STRUCINTERFLIST%", GetStrucInterfDetailsList())
    Else
      Template = ReplaceString(Template, "%STRUCINTERFLIST%", "")
    EndIf
    
    Template = ReplaceString(Template, "%OVERVIEWPLACE%", Overview)
    
    
    WriteString(FileID, Template)
    
    CloseFile(FileID)
    ProcedureReturn #True
  EndIf
  
  ProcedureReturn #False
EndProcedure

;** main: main function
Procedure.l main()
  Protected inFileName.s, outFileName.s, TemplateString.s
  
  TemplateString = PeekS(?pbdoctemplate, ?endpbdoctemplate - ?pbdoctemplate, #PB_UTF8)
  GetFileNameFromParameter()
  
  ForEach filestoparse()
    inFileName = filestoparse()\s
    glob\CurrentFileName = GetFilePart(inFileName)
    If FileSize(inFileName) <= 0
      PrintN("Error: File not found: " + inFileName)
      ProcedureReturn 0 
    EndIf
    If Not LoadFile(inFileName) 
      PrintN("Error: Could not load file: " + inFileName)
      ProcedureReturn 0
    EndIf
    If Not ProcessFile() 
      PrintN("Error: Could not process file: " + inFileName)
      ProcedureReturn 0 
    EndIf
  Next
  
  ForEach filestoparse()
    inFileName = filestoparse()\s
    outFileName = inFileName + ".html"
    glob\CurrentFileName = GetFilePart(inFileName)
    If Not WriteOutFile(inFileName, outFileName, TemplateString.s) 
      PrintN("Error: Could not write file: " + outFileName)
      Break
    EndIf
  Next
  
  ProcedureReturn 1
EndProcedure


OpenConsole()
If main() = 0
  PrintN("Error: Couldn't parse file.")
EndIf


DataSection
pbdoctemplate:
IncludeBinary "PBDoc.html"
endpbdoctemplate:
EndDataSection
; IDE Options = PureBasic 5.42 LTS (Windows - x64)
; ExecutableFormat = Console
; CursorPosition = 1669
; FirstLine = 1644
; Folding = --------
; Executable = ..\jaPBDoc.exe
; CommandLine = C:\Users\user\Desktop\_sgx\sgx_define.pbi /nosort /notstart "sgx_;*sgx" /stylesheet css.css
; CompileSourceDirectory